<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="学生id" prop="studentId">
        <el-input v-model="queryParams.studentId" placeholder="请输入学生id" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="对应计划" prop="planId">
        <el-input v-model="queryParams.planId" placeholder="请输入对应计划" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="月份序号" prop="monthSeq">
        <el-input v-model="queryParams.monthSeq" placeholder="请输入月份序号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="周序号" prop="weekSeq">
        <el-input v-model="queryParams.weekSeq" placeholder="请输入周序号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="学习日期" prop="reportDate">
        <el-date-picker clearable v-model="queryParams.reportDate" type="date" value-format="YYYY-MM-DD"
          class="w-[170px]!" placeholder="请选择学习日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="完成题数" prop="questionCount">
        <el-input v-model="queryParams.questionCount" placeholder="请输入完成题数" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="完成视频时间" prop="videoTime">
        <el-input v-model="queryParams.videoTime" placeholder="请输入完成视频时间" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="计划做题数" prop="questionPlan">
        <el-input v-model="queryParams.questionPlan" placeholder="请输入计划做题数" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="计划视频时间" prop="videoPlan">
        <el-input v-model="queryParams.videoPlan" placeholder="请输入计划视频时间" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:learnPlanStudy:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:learnPlanStudy:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:learnPlanStudy:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:learnPlanStudy:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="learnPlanStudyList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" fixed="left" />
      <!-- <el-table-column label="计划学习id" align="center" prop="id" fixed="left" min-width="100" /> -->
      <el-table-column label="学生id" align="center" prop="studentId" fixed="left" />
      <el-table-column label="对应计划" align="center" prop="planId" />
      <el-table-column label="月份序号" align="center" prop="monthSeq" />
      <el-table-column label="周序号" align="center" prop="weekSeq" />
      <el-table-column label="学习日期" align="center" prop="reportDate" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.reportDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="完成题数" align="center" prop="questionCount" />
      <el-table-column label="完成视频时间" align="center" prop="videoTime" min-width="120" />
      <el-table-column label="计划做题数" align="center" prop="questionPlan" min-width="100" />
      <el-table-column label="计划视频时间" align="center" prop="videoPlan" min-width="120" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="120" fixed="right">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:learnPlanStudy:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:learnPlanStudy:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改学生计划执行情况对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="learnPlanStudyRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="学生id" prop="studentId">
          <el-input v-model="form.studentId" placeholder="请输入学生id" />
        </el-form-item>
        <el-form-item label="对应计划" prop="planId">
          <el-input v-model="form.planId" placeholder="请输入对应计划" />
        </el-form-item>
        <el-form-item label="月份序号" prop="monthSeq">
          <el-input v-model="form.monthSeq" placeholder="请输入月份序号" />
        </el-form-item>
        <el-form-item label="周序号" prop="weekSeq">
          <el-input v-model="form.weekSeq" placeholder="请输入周序号" />
        </el-form-item>
        <el-form-item label="学习日期" prop="reportDate">
          <el-date-picker clearable v-model="form.reportDate" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择学习日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="完成题数" prop="questionCount">
          <el-input v-model="form.questionCount" placeholder="请输入完成题数" />
        </el-form-item>
        <el-form-item label="完成视频时间" prop="videoTime">
          <el-input v-model="form.videoTime" placeholder="请输入完成视频时间" />
        </el-form-item>
        <el-form-item label="计划做题数" prop="questionPlan">
          <el-input v-model="form.questionPlan" placeholder="请输入计划做题数" />
        </el-form-item>
        <el-form-item label="计划视频时间" prop="videoPlan">
          <el-input v-model="form.videoPlan" placeholder="请输入计划视频时间" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LearnPlanStudy">
import { listLearnPlanStudy, getLearnPlanStudy, delLearnPlanStudy, addLearnPlanStudy, updateLearnPlanStudy } from "@/api/learn/learnPlanStudy"

const { proxy } = getCurrentInstance()

const learnPlanStudyList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    studentId: null,
    planId: null,
    monthSeq: null,
    weekSeq: null,
    reportDate: null,
    questionCount: null,
    videoTime: null,
    questionPlan: null,
    videoPlan: null,
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询学生计划执行情况列表 */
function getList() {
  loading.value = true
  listLearnPlanStudy(queryParams.value).then(response => {
    learnPlanStudyList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    studentId: null,
    planId: null,
    monthSeq: null,
    weekSeq: null,
    reportDate: null,
    questionCount: null,
    videoTime: null,
    questionPlan: null,
    videoPlan: null,
    updateTime: null
  }
  proxy.resetForm("learnPlanStudyRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加学生计划执行情况"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getLearnPlanStudy(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改学生计划执行情况"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["learnPlanStudyRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateLearnPlanStudy(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addLearnPlanStudy(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除学生计划执行情况编号为"' + _ids + '"的数据项？').then(function () {
    return delLearnPlanStudy(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/learnPlanStudy/export', {
    ...queryParams.value
  }, `learnPlanStudy_${new Date().getTime()}.xlsx`)
}

getList()
</script>
